/** Source code example for "A Practical Introduction to Data
    Structures and Algorithm Analysis, 3rd Edition (Java)" 
    by Clifford A. Shaffer
    Copyright 2008-2011 by Clifford A. Shaffer
*/

class HuffTree { // A Huffman coding tree
  private HuffNode<LettFreq> root;  // Root of the tree

  public HuffTree(LettFreq val)
    { root = new HuffNode<LettFreq>(val); }
  public HuffTree(LettFreq val, HuffTree l, HuffTree r) {
    root = new HuffNode<LettFreq>(val, l.root(), r.root());
  }
  public HuffNode<LettFreq> root() { return root; }
  public int weight() // Weight of tree is weight of root
    { return root.element().weight(); }
}
